/*  

 Small pointless program that counts time in Klingon

	by Em Tonkin, 9-April-2001

Soon to come: Small pointless program that /also/ counts stardates in Klingon
Might even make it count in human  numbers underneath. 

Problems: my version of the font is disgusting. Mea culpa.

Inspiration and generation of the nicer, neater version of the XPM file are both credited to Greg Tourte, who is kind enough to volunteer time and effort on some of the most unlikely-sounding projects.    

Despite the fact that a Klingon clock almost beats Xeyes in the race for 'Most Pointless Docking Application' awards.

*/

#include <stdio.h>
#include <time.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <math.h>

#include <sys/wait.h>
#include <sys/param.h>
#include <sys/types.h>

#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <X11/extensions/shape.h>
#include "../wmgeneral/wmgeneral.h"
#include "../wmgeneral/misc.h"
/*foo*/
#include "wmTrek-mask.xbm"
#include "wmTrek.xpm"
#define VERSION 0.1
#define CHAR_WIDTH 12
#define CHAR_HEIGHT 15 

void DrawTime(int hr, int min, int sec, int msec);
void writeNum(int num, int x, int y);
void writeString(char *name, int x, int y);
void writeArrow(char *Arrow, int x, int y);
void drawEmpty(int x, int y);

char wminet_mask_bits[64*64];
int  wminet_mask_width = 64;
int  wminet_mask_height = 64;
char *ProgName;
char *action;
int actdef=0;


int main(int argc, char *argv[]) {
	int i;
	int myCount=0;
	int buttonStatus=-1;
	XEvent Event;
	long starttime;
	long curtime;
	long nexttime;
	struct tm *time_struct;
	struct tm old_time_struct;
	//struct timespec *time_struct_2;
	//struct timespec old_time_struct_2;	

	/* Ought to have some stuff in here about command line options */

	/* Make the xbm from the xpm... */
	createXBMfromXPM(wminet_mask_bits, wmTrek_xpm, wminet_mask_width, wminet_mask_height);

	/* open the x window */
	openXwindow(argc, argv, wmTrek_xpm, wmTrek_mask_bits, wmTrek_mask_width, wmTrek_mask_height);	
        AddMouseRegion(0, 18, 49, 45, 59 ); /* middle button */
        AddMouseRegion(1, 5 , 49, 17, 59 ); /* left button   */
        AddMouseRegion(2, 46, 49, 59, 59 ); /* right button  */
	//        AddMouseRegion(3, 2, 2, 58, 33);    /* main area     */
        AddMouseRegion(3, 6, 2, 60, 18);   /*first bar      */
        AddMouseRegion(4, 6, 20, 60, 34);   /*first bar      */
        AddMouseRegion(5, 6, 37, 60, 48);   /*third bar      */


	setMaskXY(-64,0);	
	starttime = time(0);
        nexttime = starttime + 1;
	//clock_gettime(,*time_struct_2);
        curtime = time(0);
	/* endless loop redraws whenever necessary */
	while(1) {
	
		curtime= time(0);
		waitpid(0, NULL, WNOHANG);
		old_time_struct = *time_struct;
                time_struct = localtime(&curtime);
		if(myCount>= 99) {
			myCount=0;
		 	drawEmpty(5,40);
		} else {
			myCount++;
		} 	
		if(curtime>=starttime) {
			/* Change the time on the clock */
			DrawTime(time_struct->tm_hour, time_struct->tm_min, time_struct->tm_sec, myCount);
			//RedrawWindow();	
			/*It'll redraw every second, basically*/
	RedrawWindow();

	/* Deal with xevent thing */
    while (XPending (display)) {
      XNextEvent (display, &Event);
      switch (Event.type) {
		case Expose:
		   RedrawWindow (); 
		   break;
	        case DestroyNotify:
		   XCloseDisplay (display);
		   exit (0);
	           break;
	       case ButtonPress:
	         i = CheckMouseRegion(Event.xbutton.x, Event.xbutton.y);
                 buttonStatus = i;
                 if (buttonStatus == i && buttonStatus >= 0){
                       switch (buttonStatus){
                                case 0 :
                                	break;
                                case 1 :
                                       break;
                                case 2:
                                       break;
                                case 3:
                                            //execCommand(mailclient);
                                       break;
                                case 4:
                                       break;
                                }
                         }
			/* end of if(buttonstatus loop) */
                    break;
                    case ButtonRelease:
                            i = CheckMouseRegion(Event.xbutton.x, Event.xbutton.y);

                if (buttonStatus == i && buttonStatus >= 0){
                    switch (buttonStatus){
                        case 0 :
                            break;
                       case 1 :
                             break;
                        case 2:
                            break;
                        case 3:
                            break;
                        case 4:
                            break;
                        case 5:
                            break;
                                        }
                                }
                                buttonStatus = -1;
                                RedrawWindow();
                                break;
                        	}
			}
        //i = CheckMouseRegion (Event.xbutton.x, Event.xbutton.y);
        //copyXPMArea (prs[i].x, prs[i].y, prs[i].w, prs[i].h, pos[i].x, pos[i].y);

		usleep(10000L);
		}
	/* end of endless loop, heh*/
	}
	return 0;
}

void DrawTime(int hr, int min, int sec, int msec) {
	// We send the numbers to write along with the positions to write them to our write functions.
	/* We need various modes here really, stardate mode and hour/second modes */
	writeNum(hr,5,10); 
	writeString(":",35,7);
	
	writeNum(min,33,10);
	writeArrow("L",5,25);
	writeNum(sec,20,25);
	writeArrow("R",45,25);
	writeNum(msec,22,42);
	writeArrow("L",5,42);
	writeArrow("R",45,42);
}
 
void writeNum(int num, int x, int y){
	/*This just turns the number into a string for the writeString */
	/* printf("I am a goldfish!\n");*/
	    char buf[1024];
    int newx=x;
    if (num > 99)
    {
        newx -= CHAR_WIDTH;
    }

    if (num > 999)
    {
        newx -= CHAR_WIDTH;
    }

    sprintf(buf, "%02i", num);
    writeString(buf, newx, y);


}
void writeArrow(char *Arrow,int x, int y) {
	 char c=toupper(Arrow[0]);
 	if (c=='R') {
		/* Left arrow */
                copyXPMArea(132, 85, 12, 12, x, y);
	} else {
		/*Assume it's right arrow*/
		copyXPMArea(120,85,12,12,x,y);
	}
}

void drawEmpty(int x, int y) {
	copyXPMArea(82, CHAR_HEIGHT,CHAR_WIDTH*4,CHAR_HEIGHT,x,y);

}
void writeString(char *name, int x, int y) {

    int         i;
    int         c;
    int         k;

        k = x;
    for (i=0; name[i]; i++)
    {
        c = toupper(name[i]);
        if (c >= 'A' && c <= 'Z')
        {   // its a letter
                        c -= 'A';
                        copyXPMArea(c * 6,12 , 6, 8, k, y);
                        k += CHAR_WIDTH;
        }
        else
        {   // its a number or symbol
                        c -= '0';
                        copyXPMArea(c * 12, 85, 12, 12, k, y);
                        k += 12;
                }
       }

}
